#include <iostream>
#include <math.h>

using namespace std;

bool isSquare(long long x) {
    long long l = -1;
    long long r = x + 1;
    long long m = (l + r) / 2;
    while(r - l > 1) {
        if(m * m < x) {
            l = m;
        } else if(m * m > x) {
            r = m;
        } else {
            return true;
        }
        m = (l + r) / 2;
    }
    return false;
}

long long llSqrt(long long x) {
    long long l = -1;
    long long r = x + 1;
    long long m = (l + r) / 2;
    while(r - l > 1) {
        if(m * m < x) {
            l = m;
        } else if(m * m > x) {
            r = m;
        } else {
            return m;
        }
        m = (l + r) / 2;
    }
}

long long mod(long long x) {
    return x >= 0 ? x : -x;
}

int main()
{
    long long k;
    cin >> k;
    if((k != 0 and (mod(k) - 2) % 4 == 0) or (-9 <= k <= -1 and (k == -1 or k == -2 or k == -4 or k == -6))) {
        cout << "none" << endl;
        return 0;
    }

    for(long long x = 0, cur; x <= 2000000; x++) {
        cur = x * x;
        if(x * x - k == 0) {
            cout << "0" << endl;
            return 0;
        }
        if(x * x - k > 0 and isSquare(x * x - k)) {
            cout << x << endl;
            return 0;
        }
    }
    cout << "none" << endl;

    return 0;
}
