#include <iostream>
#include <math.h>

using namespace std;

bool isSquare(long long x) {
    long long l = 0;
    long long r = x;
    long long m = (l + r) / 2;
    while(r - l > 1) {
        if(m * m < x) {
            l = m;
        } else if(m * m > x) {
            r = m;
        } else {
            return true;
        }
        m = (l + r) / 2;
    }
    return false;
}

long long llSqrt(long long x) {
    long long l = 0;
    long long r = x;
    long long m = (l + r) / 2;
    while(r - l > 1) {
        if(m * m < x) {
            l = m;
        } else if(m * m > x) {
            r = m;
        } else {
            return m;
        }
        m = (l + r) / 2;
    }
}

int main()
{
    long long k;
    cin >> k;
    if((abs(k) - 2) % 4 == 0) {
        cout << "none" << endl;
        return 0;
    }

    for(long long x = 1, cur; x <= 1e7; x++) {
        cur = k + x * x;
        if(cur >= 0 and isSquare(cur)) {
            cout << ((int) llSqrt(cur)) << endl;
            break;
        }
    }

    return 0;
}
